#include <stdio.h>
#include <errno.h>
#include "buffer.h"
#include "fread.h"

int file_read_all(const char *fn, unsigned char **Rd, size_t *Rl)
{
  FILE *f;
  buffer_t *b;
  char rb[1024];
  int R;
  int eno;
  f= fopen(fn,"rb");
  if (!f) return 1;
  b= buffer_new(1024);
  while(1)
  {
    R= fread(rb, 1, sizeof(rb), f);
    if (R<=0)
    {
      eno= errno;
      if (ferror(f)) 
        { buffer_free(b, NULL,NULL);
          fclose(f); errno= eno;
          return 1; }
      break;
    }
    buffer_write(b, rb, R);
  } 
  fclose(f);
  rb[0]= 0;
  buffer_write(b, rb, 1);
  buffer_free(b, (void**) Rd, Rl);
  return 0;
}
